/* -*- buffer-read-only: t -*- vi: set ro:
#line 636
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 636
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>

static size_t debug_handle;
/* This must be defined before including debug.h */
#define MF_SOURCE_NAME  debug_handle

#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 15 "vars.bi"
/* This file is part of Mailfromd.             -*- c -*-
#line 15
   Copyright (C) 2006-2011 Sergey Poznyakoff
#line 15

#line 15
   This program is free software; you can redistribute it and/or modify
#line 15
   it under the terms of the GNU General Public License as published by
#line 15
   the Free Software Foundation; either version 3, or (at your option)
#line 15
   any later version.
#line 15

#line 15
   This program is distributed in the hope that it will be useful,
#line 15
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 15
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 15
   GNU General Public License for more details.
#line 15

#line 15
   You should have received a copy of the GNU General Public License
#line 15
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

static size_t rcpt_count_loc
#line 17 "vars.bi"
;
static size_t ehlo_domain_loc
#line 18 "vars.bi"
;
static size_t mailfrom_address_loc
#line 19 "vars.bi"
;
static size_t milter_client_family_loc
#line 20 "vars.bi"
;
static size_t milter_client_address_loc
#line 21 "vars.bi"
;
static size_t milter_server_family_loc
#line 22 "vars.bi"
;
static size_t milter_server_address_loc
#line 23 "vars.bi"
;
static size_t milter_server_id_loc
#line 24 "vars.bi"
;
       
/* Functions to access %rcpt_count */
unsigned long
get_rcpt_count(eval_environ_t env)
{
 	return (long) *env_data_ref(env, rcpt_count_loc) ;
}

void
clear_rcpt_count(eval_environ_t env)
{
	*env_data_ref(env, rcpt_count_loc) = (STKVAL) (0);
}

void
incr_rcpt_count(eval_environ_t env)
{
	env_var_inc(env, rcpt_count_loc);
}


/* define_milter_address name */
#line 75

	  

#line 77
void
#line 77
set_milter_server_address(eval_environ_t env, milter_sockaddr_t *addr,
#line 77
		      socklen_t len)
#line 77
{
#line 77
	char *path;
#line 77
	
#line 77
	switch (addr->sa.sa_family) {
#line 77
	case PF_INET:
#line 77
		*env_data_ref(env, milter_server_family_loc) = (STKVAL) (MFAM_INET);
#line 77
		
#line 77
{ size_t __off;
#line 77
  const char *__s = inet_ntoa(addr->sin.sin_addr);
#line 77
  if (__s)
#line 77
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 77
  else
#line 77
     __off = 0;
#line 77
  *env_data_ref(env, milter_server_address_loc) = (STKVAL) (__off); }
#line 77
;
#line 77
		break;
#line 77

#line 77
	case PF_UNIX:
#line 77
		*env_data_ref(env, milter_server_family_loc) = (STKVAL) (MFAM_UNIX);
#line 77
		if (len == sizeof (addr->sa.sa_family))
#line 77
			path = "";
#line 77
		else
#line 77
			path = addr->sunix.sun_path;
#line 77
		
#line 77
{ size_t __off;
#line 77
  const char *__s = path;
#line 77
  if (__s)
#line 77
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 77
  else
#line 77
     __off = 0;
#line 77
  *env_data_ref(env, milter_server_address_loc) = (STKVAL) (__off); }
#line 77
;
#line 77
		break;
#line 77

#line 77
	default:
#line 77
		/* FIXME */
#line 77
		*env_data_ref(env, milter_server_family_loc) = (STKVAL) ((int)addr->sa.sa_family);
#line 77
	}
#line 77
}
#line 77


#line 78
void
#line 78
set_milter_client_address(eval_environ_t env, milter_sockaddr_t *addr,
#line 78
		      socklen_t len)
#line 78
{
#line 78
	char *path;
#line 78
	
#line 78
	switch (addr->sa.sa_family) {
#line 78
	case PF_INET:
#line 78
		*env_data_ref(env, milter_client_family_loc) = (STKVAL) (MFAM_INET);
#line 78
		
#line 78
{ size_t __off;
#line 78
  const char *__s = inet_ntoa(addr->sin.sin_addr);
#line 78
  if (__s)
#line 78
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 78
  else
#line 78
     __off = 0;
#line 78
  *env_data_ref(env, milter_client_address_loc) = (STKVAL) (__off); }
#line 78
;
#line 78
		break;
#line 78

#line 78
	case PF_UNIX:
#line 78
		*env_data_ref(env, milter_client_family_loc) = (STKVAL) (MFAM_UNIX);
#line 78
		if (len == sizeof (addr->sa.sa_family))
#line 78
			path = "";
#line 78
		else
#line 78
			path = addr->sunix.sun_path;
#line 78
		
#line 78
{ size_t __off;
#line 78
  const char *__s = path;
#line 78
  if (__s)
#line 78
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 78
  else
#line 78
     __off = 0;
#line 78
  *env_data_ref(env, milter_client_address_loc) = (STKVAL) (__off); }
#line 78
;
#line 78
		break;
#line 78

#line 78
	default:
#line 78
		/* FIXME */
#line 78
		*env_data_ref(env, milter_client_family_loc) = (STKVAL) ((int)addr->sa.sa_family);
#line 78
	}
#line 78
}
#line 78


void
set_milter_server_id(eval_environ_t env, const char *id)
{
	
#line 83
{ size_t __off;
#line 83
  const char *__s = id ? id : "";
#line 83
  if (__s)
#line 83
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 83
  else
#line 83
     __off = 0;
#line 83
  *env_data_ref(env, milter_server_id_loc) = (STKVAL) (__off); }
#line 83
;
}

void
builtin_post_setup()
{
	struct value val;
	char *smtp_hostname;
	char *smtp_domain;
	mu_get_host_name(&smtp_hostname);

	smtp_domain = strchr(smtp_hostname, '.');
	if (smtp_domain)
		smtp_domain++;
	else
		smtp_domain = smtp_hostname;
		
	val.type = dtype_string;
	val.v.literal = string_alloc(smtp_domain, strlen(smtp_domain));
	free(smtp_hostname);
	ensure_initialized_variable("ehlo_domain", &val);
	
	val.type = dtype_string;
	val.v.literal = string_alloc(DEFAULT_FROM_ADDRESS,
				     sizeof(DEFAULT_FROM_ADDRESS) - 1);
	ensure_initialized_variable("mailfrom_address", &val);
}


#line 111
void
#line 111
vars_init_builtin()
#line 111
{
#line 111
        debug_handle = debug_register("bi_vars");
#line 111
	#line 17 "vars.bi"
	builtin_variable_install("rcpt_count", dtype_number, SYM_VOLATILE, &rcpt_count_loc);
#line 18 "vars.bi"
	builtin_variable_install("ehlo_domain", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &ehlo_domain_loc);
#line 19 "vars.bi"
	builtin_variable_install("mailfrom_address", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &mailfrom_address_loc);
#line 20 "vars.bi"
	builtin_variable_install("milter_client_family", dtype_number, SYM_VOLATILE|SYM_PRECIOUS, &milter_client_family_loc);
#line 21 "vars.bi"
	builtin_variable_install("milter_client_address", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &milter_client_address_loc);
#line 22 "vars.bi"
	builtin_variable_install("milter_server_family", dtype_number, SYM_VOLATILE|SYM_PRECIOUS, &milter_server_family_loc);
#line 23 "vars.bi"
	builtin_variable_install("milter_server_address", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &milter_server_address_loc);
#line 24 "vars.bi"
	builtin_variable_install("milter_server_id", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &milter_server_id_loc);

#line 111 "vars.bi"
	
#line 111
}
#line 111

#line 627 "../../mfd/builtin/snarf.m4"

#line 627

